/***************************************************************************
 *   copyright       : (C) 2012-2021 by Pascal Brachet                     *
 *   https://www.xm1math.net/pdfadd/                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/


#include "aidedialog.h"

#include <QFile>
#include <QTextStream>
#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
    #include <QtCore/QTextCodec>
#else
    #include <QtCore5Compat/QTextCodec>
#endif


AideDialog::AideDialog(QWidget *parent,QString module)
    :QDialog( parent)
{
ui.setupUi(this);
setModal(true);
QTextCodec *codec = QTextCodec::codecForName("UTF-8");
QString contenu;
QFile apropos(":/documents/apropos.txt");
apropos.open(QIODevice::ReadOnly);
contenu=codec->toUnicode(apropos.readAll());
apropos.close();
ui.textEditApropos->setHtml(contenu);

contenu="";
QFile doc;
if (module=="courbes") doc.setFileName(":/documents/aidecourbes.txt");
else if (module=="tabvar") doc.setFileName(":/documents/aidetabvar.txt");
else if (module=="arbre") doc.setFileName(":/documents/aidearbre.txt");
else if (module=="geometrie") doc.setFileName(":/documents/aidegeometrie.txt");
else if (module=="graphe") doc.setFileName(":/documents/aidegraphe.txt");
else if (module=="boites") doc.setFileName(":/documents/aideboites.txt");
else if (module=="suites") doc.setFileName(":/documents/aidesuites.txt");
else if (module=="histogramme") doc.setFileName(":/documents/aidehistogramme.txt");
else if (module=="binomiale") doc.setFileName(":/documents/aidebinomiale.txt");
else if (module=="cercle") doc.setFileName(":/documents/aidecercle.txt");
else if (module=="espace") doc.setFileName(":/documents/aideespace.txt");
else doc.setFileName(":/documents/apropos.txt");
doc.open(QIODevice::ReadOnly);
contenu=codec->toUnicode(doc.readAll());
doc.close();
ui.textEditAide->setHtml(contenu);
}

AideDialog::~AideDialog(){
}
