/***************************************************************************
 *   copyright       : (C) 2012-2021 by Pascal Brachet                     *
 *   https://www.xm1math.net/pdfadd/                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/

#ifndef ASYEDITOR_H
#define ASYEDITOR_H

#include <QWidget>
#include <QString>
#include <QTextEdit>
#include <QTextDocument>
#include <QTextCursor>
#include <QTextBlock>
#include <QContextMenuEvent>


#include "highlighter.h"

class AsyEditor : public QTextEdit  {
   Q_OBJECT
public: 
	AsyEditor(QWidget *parent);
	~AsyEditor();


private:
  Highlighter *highlighter;
private slots:
void save();
protected:
void contextMenuEvent(QContextMenuEvent *e);
};
#endif
