/***************************************************************************
 *   copyright       : (C) 2012-2021 by Pascal Brachet                     *
 *   https://www.xm1math.net/pdfadd/                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/

#ifndef CMDLAUNCHER_H
#define CMDLAUNCHER_H

#include <QObject>
#include <QDebug>
#include <QProcess>
#include <QString>
#include <QProgressDialog>
#include <QPointer>


class CmdLauncher : public QObject
{
    Q_OBJECT

public:
    CmdLauncher(QObject *parent = nullptr, const QString &workdir="", const QString &extrapath="");
    ~CmdLauncher();

    void launchCommand(const QString &command);
private:
    QProcess *process;
    QString message;
    QPointer<QProgressDialog> progressDialog;
    bool err_detected;
private slots:
void endProcess(int err);
void readInfoOutput();
signals:
void jobdone();
void joberror();
};

#endif // CMDLAUNCHER_H
