/***************************************************************************
 *   copyright       : (C) 2012-2021 by Pascal Brachet                     *
 *   https://www.xm1math.net/pdfadd/                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/

#ifndef EUKEDITORVIEW_H
#define EUKEDITORVIEW_H

#include <QWidget>
#include <QFont>
#include <QColor>
#include <QPointer>
#include "eukeditor.h"
#include "linenumberwidget.h"


class EukEditorView : public QWidget  {
   Q_OBJECT
public: 
EukEditorView(QWidget *parent);
~EukEditorView();
EukEditor *editor;
void setFontSize(int size);
private:
LineNumberWidget* m_lineNumberWidget;
QFont efont;
private slots:
void setLineNumberWidgetVisible( bool );
};

#endif
