/***************************************************************************
 *   copyright       : (C) 2012-2021 by Pascal Brachet                     *
 *   https://www.xm1math.net/pdfadd/                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   @license GPL-2.0+ <https://spdx.org/licenses/GPL-2.0+.html>           *
 ***************************************************************************/
//#line 2 "lexer.cpp"

//#line 4 "lexer.cpp"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 31
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <QDebug>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef unsigned int yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 132
#define YY_END_OF_BUFFER 133
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[568] =
    {   0,
        0,    0,  133,  131,    1,  128,  127,  131,  131,    3,
      131,  131,    4,  131,  131,  131,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  129,  130,
        1,   77,    0,    5,    3,    2,    0,    6,    4,    0,
        4,   78,   76,   79,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,   57,  126,  126,

      126,  126,   81,  126,  126,   58,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      123,  126,  126,  126,   68,  126,  126,   80,  126,   50,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  105,
      126,  126,  126,  126,  126,  126,   60,  126,  126,  126,
      126,   65,  126,  103,  126,  126,  126,  126,   26,  126,
      126,   56,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,   74,  126,  126,   73,  126,   82,
      126,  126,  126,  126,  126,  126,  126,  126,   66,  126,

       90,  126,  126,  126,  126,  126,  126,  126,   59,  126,
      126,  126,  126,   61,  126,  126,  126,  126,  126,  126,
      126,  126,   63,  126,  126,  126,   62,   64,  126,  126,
      126,  126,  126,   92,   70,  126,  126,  126,  126,  126,
      126,   93,  126,  126,  104,  126,  126,  126,  100,  126,
      126,  126,  126,  126,  126,   29,   97,  126,  116,   87,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,    9,  126,  126,  102,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  107,  126,  126,  126,  126,
      126,  126,  126,  126,  126,   69,  126,   67,  126,  126,

      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,   49,  109,  126,  126,  126,   25,  126,
       85,  126,  126,   75,   84,   12,  106,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,   71,   83,   91,
      126,  126,  126,  126,  126,  126,  126,  126,  101,  126,
      126,  126,   52,  126,  126,   53,  126,  126,  126,  126,
      126,  126,  126,    7,  126,  126,  126,  126,   33,  126,
       72,  126,  126,  126,  126,  115,  126,  125,  126,  126,
      126,  126,  126,  126,   89,  126,  126,  126,  126,  126,
      126,  126,   27,   11,  126,  118,  126,  117,  120,  126,

      126,  112,  126,   99,  126,   55,  126,  126,  126,  126,
      126,  126,  126,   47,  126,  126,   35,  126,  126,  126,
      126,  126,  126,  126,  126,  126,   51,  126,  126,  126,
      126,  119,   42,  126,  126,  126,  126,   98,  121,    8,
      126,   95,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,   14,  126,  126,   44,  126,  126,  126,  126,
      126,  126,  126,   94,  126,  108,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,   10,  124,  126,  126,
      126,  126,   45,   36,  126,  126,  126,   38,   86,   48,
      126,  126,  126,  113,  126,  126,   39,  126,  126,  126,

      126,   24,   46,  126,   13,   22,   43,  126,  126,  126,
      126,   18,  126,  126,   30,   28,  110,  126,  126,  126,
      126,  126,   20,   15,  126,  126,   32,   88,  126,  126,
      126,  126,   41,  126,   96,  126,  126,   34,  126,  126,
      126,  126,  126,  126,  126,  126,   19,   17,  126,  126,
      111,  126,   31,  122,  126,   37,  126,  126,   16,  114,
       54,   21,  126,  126,   40,   23,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    5,    6,    7,    8,    1,    1,    9,    1,
        1,    1,    1,    1,    1,   10,    1,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,    1,   12,   13,
       14,   15,    1,    1,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
       16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
        1,    1,    1,    1,   16,    1,   17,   18,   19,   20,

       21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
       31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
       41,   16,   42,    1,   43,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[44] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    1,
        2,    1,    1,    1,    1,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    1,    1
    } ;

static yyconst flex_int16_t yy_base[572] =
    {   0,
        0,    0,  585,  586,  582,  586,  586,  569,   41,  579,
       42,  570,   38,  566,  565,  564,    0,   33,   45,   50,
       62,   67,   71,  543,   73,   23,   92,   39,  545,  541,
       95,   94,   85,   48,  542,  552,  548,  550,  586,  586,
      568,  586,   51,  586,  566,  586,   77,  586,  557,  556,
       78,  586,  586,  586,    0,  531,  534,  528,   54,   69,
      538,  545,  105,  538,  525,  110,  519,  103,  524,  540,
      102,  525,  538,  100,  531,  518,  104,  535,  532,  522,
      116,  512,  516,  516,  112,  529,  517,   38,  516,  113,
      514,  510,  124,  510,  522,  509,  121,    0,  122,  518,

      129,  129,  130,  503,  124,    0,  499,  510,  503,  513,
      148,  509,  127,  508,  146,   64,  137,  500,  504,  155,
        0,  154,  503,  499,  507,  490,  499,    0,  495,    0,
      491,  491,  490,  492,  477,  492,  495,  496,  493,    0,
      485,  476,  492,  481,  478,  483,    0,  472,  476,  478,
      480,    0,  138,  467,  484,  462,  479,  474,    0,  473,
      472,  465,  464,  469,  457,  463,  463,  449,  468,  466,
      464,  469,  454,  463,  458,  461,  446,  459,  456,  454,
      456,  455,  444,  447,    0,  448,  440,  440,  436,    0,
      444,  444,  450,  430,  433,  429,  433,  436,  436,  424,

        0,  431,  434,  440,  426,  426,  424,  421,    0,  416,
      434,  419,  421,    0,  429,  160,  164,  411,  410,  409,
      416,  418,    0,  406,  420,  401,    0,    0,  160,  420,
      408,  418,  409,    0,    0,  414,  406,  401,  398,  412,
      395,    0,  406,  407,    0,  410,  405,  397,    0,  394,
      391,  388,  393,  386,  385,    0,    0,  397,    0,    0,
      387,  388,  391,  391,  377,  378,  377,  376,  390,  380,
      371,  370,    0,  375,  370,    0,  386,  371,  367,  366,
      369,  367,  164,  380,  375,    0,  359,  373,  356,  375,
      370,  354,  353,  368,  366,    0,  358,    0,  351,  357,

      362,  355,  360,  345,  349,  351,  349,  345,  350,  353,
      342,  337,  334,    0,    0,  336,  352,  347,    0,  331,
        0,  332,  344,    0,    0,    0,    0,  330,  343,  332,
      341,  339,  323,  323,  336,  339,  319,    0,    0,    0,
      329,  317,  321,  327,  332,  330,  168,  327,    0,  323,
      323,  309,    0,  314,  318,    0,  311,  324,  321,  308,
      310,  314,  306,    0,  316,  299,  303,  313,    0,  306,
        0,  300,  308,  307,  306,    0,  296,    0,  297,  301,
      288,  301,  287,  301,    0,  280,  283,  297,  282,  287,
      284,  282,    0,    0,  295,    0,  292,    0,  293,  275,

      287,    0,  271,    0,  276,    0,  275,  283,  272,  274,
      282,  279,  271,    0,  264,  280,    0,  266,  256,  258,
      272,  264,  270,  259,  269,  252,    0,  264,  250,  254,
      248,    0,    0,  248,  261,  264,  252,    0,    0,    0,
      258,    0,  261,  256,  245,  253,  238,  239,  231,  250,
      236,  244,    0,  247,  246,    0,  247,  237,  243,  227,
      243,  240,  243,    0,  223,    0,  237,  227,  239,  227,
      224,  228,  227,  223,  225,  219,    0,    0,  213,  211,
      225,  210,    0,    0,  205,  215,  221,    0,    0,    0,
      207,  221,  205,    0,  197,  220,    0,  211,  199,  199,

      192,    0,    0,  196,    0,  200,    0,  211,  198,  207,
      196,    0,  191,  200,    0,    0,    0,  199,  189,  191,
      196,  203,    0,    0,  181,  193,    0,    0,  196,  193,
      178,  184,    0,  183,    0,  181,  181,    0,  171,  166,
      173,  179,  168,  164,  163,  167,    0,    0,  164,  172,
        0,  150,    0,    0,  159,    0,  170,  169,    0,    0,
        0,    0,  132,  121,    0,    0,  586,  203,  205,  207,
       44
    } ;

static yyconst flex_int16_t yy_def[572] =
    {   0,
      567,    1,  567,  567,  567,  567,  567,  567,  568,  569,
      570,  567,  567,  567,  567,  567,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  567,  567,
      567,  567,  568,  567,  569,  567,  570,  567,  567,  567,
      567,  567,  567,  567,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,

      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,

      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,

      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,

      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,

      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,  571,  571,  571,  571,
      571,  571,  571,  571,  571,  571,    0,  567,  567,  567,
      567
    } ;

static yyconst flex_int16_t yy_nxt[630] =
    {   0,
        4,    5,    6,    7,    8,    9,   10,   11,    4,   12,
       13,    7,   14,   15,   16,   17,   18,   19,   20,   21,
       22,   23,   24,   25,   26,   17,   17,   27,   28,   29,
       30,   31,   17,   32,   33,   34,   35,   36,   37,   17,
       38,   39,   40,   44,   48,   55,   44,   50,   51,   48,
       56,   57,   93,   44,  168,   99,   44,   94,  169,  100,
       58,   63,   59,  101,  118,   64,   60,   61,   62,   65,
       68,  119,   66,  128,   69,   67,  129,   70,   74,   48,
       71,  120,   75,   72,   48,   79,   76,   50,   51,   89,
       73,  130,   77,   90,   80,   78,   81,  210,   84,   82,

      211,   85,  131,   91,   86,  114,   83,   87,   95,  115,
      110,  104,   96,   92,  111,  105,   97,  116,  112,  106,
      117,   98,  107,  134,  113,  108,  138,  141,  109,  145,
      164,  146,  142,  150,  151,  159,  147,  171,  135,  154,
      155,  165,  175,  180,  182,  189,  139,  183,  187,  191,
      181,  160,  172,  194,  566,  184,  245,  195,  188,  176,
      565,  185,  204,  205,  190,  192,  200,  201,  207,  202,
      212,  216,  218,  246,  208,  209,  316,  213,  303,  217,
      305,  360,  306,  317,  411,  564,  563,  219,  562,  304,
      561,  361,  560,  559,  558,  307,  557,  556,  555,  554,

      553,  552,  412,   43,   43,   45,   45,   47,   47,  551,
      550,  549,  548,  547,  546,  545,  544,  543,  542,  541,
      540,  539,  538,  537,  536,  535,  534,  533,  532,  531,
      530,  529,  528,  527,  526,  525,  524,  523,  522,  521,
      520,  519,  518,  517,  516,  515,  514,  513,  512,  511,
      510,  509,  508,  507,  506,  505,  504,  503,  502,  501,
      500,  499,  498,  497,  496,  495,  494,  493,  492,  491,
      490,  489,  488,  487,  486,  485,  484,  483,  482,  481,
      480,  479,  478,  477,  476,  475,  474,  473,  472,  471,
      470,  469,  468,  467,  466,  465,  464,  463,  462,  461,

      460,  459,  458,  457,  456,  455,  454,  453,  452,  451,
      450,  449,  448,  447,  446,  445,  444,  443,  442,  441,
      440,  439,  438,  437,  436,  435,  434,  433,  432,  431,
      430,  429,  428,  427,  426,  425,  424,  423,  422,  421,
      420,  419,  418,  417,  416,  415,  414,  413,  410,  409,
      408,  407,  406,  405,  404,  403,  402,  401,  400,  399,
      398,  397,  396,  395,  394,  393,  392,  391,  390,  389,
      388,  387,  386,  385,  384,  383,  382,  381,  380,  379,
      378,  377,  376,  375,  374,  373,  372,  371,  370,  369,
      368,  367,  366,  365,  364,  363,  362,  359,  358,  357,

      356,  355,  354,  353,  352,  351,  350,  349,  348,  347,
      346,  345,  344,  343,  342,  341,  340,  339,  338,  337,
      336,  335,  334,  333,  332,  331,  330,  329,  328,  327,
      326,  325,  324,  323,  322,  321,  320,  319,  318,  315,
      314,  313,  312,  311,  310,  309,  308,  302,  301,  300,
      299,  298,  297,  296,  295,  294,  293,  292,  291,  290,
      289,  288,  287,  286,  285,  284,  283,  282,  281,  280,
      279,  278,  277,  276,  275,  274,  273,  272,  271,  270,
      269,  268,  267,  266,  265,  264,  263,  262,  261,  260,
      259,  258,  257,  256,  255,  254,  253,  252,  251,  250,

      249,  248,  247,  244,  243,  242,  241,  240,  239,  238,
      237,  236,  235,  234,  233,  232,  231,  230,  229,  228,
      227,  226,  225,  224,  223,  222,  221,  220,  215,  214,
      206,  203,  199,  198,  197,  196,  193,  186,  179,  178,
      177,  174,  173,  170,  167,  166,  163,  162,  161,  158,
      157,  156,  153,  152,  149,  148,  144,  143,  140,  137,
      136,  133,  132,  127,  126,  125,   49,   49,   46,   41,
      124,  123,  122,  121,  103,  102,   88,   54,   53,   52,
       49,   46,   42,   41,  567,    3,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,

      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567
    } ;

static yyconst flex_int16_t yy_chk[630] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    9,   11,  571,    9,   13,   13,   11,
       18,   18,   26,   43,   88,   28,   43,   26,   88,   28,
       18,   19,   18,   28,   34,   19,   18,   18,   18,   19,
       20,   34,   19,   59,   20,   19,   59,   20,   21,   47,
       20,   34,   21,   20,   47,   22,   21,   51,   51,   25,
       20,   60,   21,   25,   22,   21,   22,  116,   23,   22,

      116,   23,   60,   25,   23,   33,   22,   23,   27,   33,
       32,   31,   27,   25,   32,   31,   27,   33,   32,   31,
       33,   27,   31,   63,   32,   31,   66,   68,   31,   71,
       85,   71,   68,   74,   74,   81,   71,   90,   63,   77,
       77,   85,   93,   97,   99,  102,   66,   99,  101,  103,
       97,   81,   90,  105,  564,   99,  153,  105,  101,   93,
      563,   99,  113,  113,  102,  103,  111,  111,  115,  111,
      117,  120,  122,  153,  115,  115,  229,  117,  216,  120,
      217,  283,  217,  229,  347,  558,  557,  122,  555,  216,
      552,  283,  550,  549,  546,  217,  545,  544,  543,  542,

      541,  540,  347,  568,  568,  569,  569,  570,  570,  539,
      537,  536,  534,  532,  531,  530,  529,  526,  525,  522,
      521,  520,  519,  518,  514,  513,  511,  510,  509,  508,
      506,  504,  501,  500,  499,  498,  496,  495,  493,  492,
      491,  487,  486,  485,  482,  481,  480,  479,  476,  475,
      474,  473,  472,  471,  470,  469,  468,  467,  465,  463,
      462,  461,  460,  459,  458,  457,  455,  454,  452,  451,
      450,  449,  448,  447,  446,  445,  444,  443,  441,  437,
      436,  435,  434,  431,  430,  429,  428,  426,  425,  424,
      423,  422,  421,  420,  419,  418,  416,  415,  413,  412,

      411,  410,  409,  408,  407,  405,  403,  401,  400,  399,
      397,  395,  392,  391,  390,  389,  388,  387,  386,  384,
      383,  382,  381,  380,  379,  377,  375,  374,  373,  372,
      370,  368,  367,  366,  365,  363,  362,  361,  360,  359,
      358,  357,  355,  354,  352,  351,  350,  348,  346,  345,
      344,  343,  342,  341,  337,  336,  335,  334,  333,  332,
      331,  330,  329,  328,  323,  322,  320,  318,  317,  316,
      313,  312,  311,  310,  309,  308,  307,  306,  305,  304,
      303,  302,  301,  300,  299,  297,  295,  294,  293,  292,
      291,  290,  289,  288,  287,  285,  284,  282,  281,  280,

      279,  278,  277,  275,  274,  272,  271,  270,  269,  268,
      267,  266,  265,  264,  263,  262,  261,  258,  255,  254,
      253,  252,  251,  250,  248,  247,  246,  244,  243,  241,
      240,  239,  238,  237,  236,  233,  232,  231,  230,  226,
      225,  224,  222,  221,  220,  219,  218,  215,  213,  212,
      211,  210,  208,  207,  206,  205,  204,  203,  202,  200,
      199,  198,  197,  196,  195,  194,  193,  192,  191,  189,
      188,  187,  186,  184,  183,  182,  181,  180,  179,  178,
      177,  176,  175,  174,  173,  172,  171,  170,  169,  168,
      167,  166,  165,  164,  163,  162,  161,  160,  158,  157,

      156,  155,  154,  151,  150,  149,  148,  146,  145,  144,
      143,  142,  141,  139,  138,  137,  136,  135,  134,  133,
      132,  131,  129,  127,  126,  125,  124,  123,  119,  118,
      114,  112,  110,  109,  108,  107,  104,  100,   96,   95,
       94,   92,   91,   89,   87,   86,   84,   83,   82,   80,
       79,   78,   76,   75,   73,   72,   70,   69,   67,   65,
       64,   62,   61,   58,   57,   56,   50,   49,   45,   41,
       38,   37,   36,   35,   30,   29,   24,   16,   15,   14,
       12,   10,    8,    5,    3,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,

      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
//#line 1 "lexer.l"
/*
 *  Eukleides  version 1.0.3
 *  Copyright (c) Christian Obrecht 2000-2004
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
////#line 22 "lexer.l"

#include <stdlib.h>
#include <string.h>
#include "types.h"
#include "parser.hpp"
#include "eukparser.h"

#define FILTER_MODE 0
#define NORMAL_MODE 1
#define TRACE_MODE 2
#define STRING_MODE 3
#define COMMENT_MODE 4

QString result;

//int warning(char *);

int filter, lineno, first, inputmode, strokes, undefined;

//extern int filter, undefined, lineno, drawing_style, first, inputmode;
extern int drawing_style;

int count, pos;

char * buffer;

symrec *sym_table = NULL;

/* Symbol table management */

symrec *putsym (char *sym_name)
{
    symrec *ptr;
    ptr = (symrec *)malloc (sizeof (symrec));
    ptr->name = (char *) malloc (strlen (sym_name) + 1);
    strcpy (ptr->name, sym_name);
    ptr->type = VARIABLE;
    ptr->next = sym_table;
    sym_table = ptr;
    return ptr;
}

symrec *getsym (char *sym_name)
{
    symrec *ptr;
    for (ptr = sym_table; ptr != NULL; ptr = ptr->next)
	if (strcmp (ptr->name, sym_name) == 0)
	    return ptr;
    return NULL;
}

void clearsym(void)
{
    symrec *ptr, *prev;
    ptr = sym_table;
    while (ptr != NULL) {
	free(ptr->name);
	prev = ptr;
	ptr = ptr->next;
	free(prev);
    }
    sym_table = NULL;
}

saverec *save_table = NULL;

void save(void * s)
{
    saverec *ptr;
    ptr = (saverec *)malloc(sizeof(saverec));
    ptr->s = s;
    ptr->next = save_table;
    save_table = ptr;
}

void clearsave(void)
{
    saverec *ptr, *prev;
    ptr = save_table;
    while (ptr != NULL) {
	free(ptr->s);
	prev = ptr;
	ptr = ptr->next;
	free(prev);
    }
    save_table = NULL;
}

#undef YY_INPUT
#define YY_INPUT(buf,result,max) (result = char_input(buf,max))

/* Input function */

int char_input(char *buf, int max)
{
    int n;

    static int cursor = 0, bracepos, loopcount, lastmode;

    n = 0;

    while (buffer[cursor] != '\0' && n < max) {
	buf[n] = buffer[cursor];
	switch (buffer[cursor]) {
	    case '#':
		if (inputmode == FILTER_MODE
		    && strncmp("#--eukleides",buffer+cursor,12) == 0)
		    inputmode = COMMENT_MODE;
		if (inputmode == NORMAL_MODE) {
		    inputmode = COMMENT_MODE;
		    if (strncmp("#--end",buffer+cursor,6) == 0
			|| strncmp("#--stop",buffer+cursor,7) == 0)
			inputmode = FILTER_MODE;
		};
		break;
	    case '\n':
		if (inputmode == STRING_MODE || inputmode == COMMENT_MODE)
		    inputmode = NORMAL_MODE;
		break;
	    case '"':
		if (inputmode == NORMAL_MODE || inputmode == TRACE_MODE) {
		    lastmode = inputmode;
		    inputmode = STRING_MODE;
		}
		else if (inputmode == STRING_MODE) inputmode = lastmode;
		break;
	    case '{':
		if (inputmode == NORMAL_MODE) {
		    bracepos = cursor-1;
		    buffer[cursor] = ';';
		    loopcount = 300;
		    inputmode = TRACE_MODE;
		}
		break;
	    case '}':
		if (inputmode == TRACE_MODE) {
		    if (--loopcount)
			cursor = bracepos;
		    else
			inputmode = NORMAL_MODE;
		}
	};
	cursor++; n++;
    }
    return n;
}

// int yywrap(void)
// {
//     return 1;
// }

int yyparse(void);
////#line 943 "lexer.cpp"

#define INITIAL 0

/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#ifdef _MSC_VER
#include <io.h>
#else
#include <unistd.h>
#endif



#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  );
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
////#line 177 "lexer.l"


	/* Ignore whitespace */

////#line 1097 "lexer.cpp"

	if ( (yy_init) )
		{
		(yy_init) = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 568 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 586 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
////#line 181 "lexer.l"

	YY_BREAK
/* Comments */
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
////#line 185 "lexer.l"
{ lineno++; }
	YY_BREAK
case 3:
YY_RULE_SETUP
////#line 187 "lexer.l"
{ return '\n'; }
	YY_BREAK
/* Numbers */
case 4:
YY_RULE_SETUP
////#line 191 "lexer.l"
{

    //yylval.number = atof(yytext); //ATOF BUG
    yylval.number=QString(yytext).toDouble();
    return NUMBER;
}
	YY_BREAK
/* Strings */
case 5:
/* rule 5 can match eol */
YY_RULE_SETUP
////#line 199 "lexer.l"
{

    yylval.string = strdup(yytext+1);
    if (yylval.string[yyleng-2] != '"') {
    //warning((char *)"Unterminated character string");
	lineno++;
    }
    else yylval.string[yyleng-2] = '\0';
    return STRING;
}
	YY_BREAK
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
////#line 210 "lexer.l"
{

    yylval.string = strdup(yytext);
    if (yylval.string[yyleng-1] != '$') {
    //warning((char *)"Unterminated character string");
	lineno++;
    }
    return STRING;
}
	YY_BREAK
/* Reserved words */
case 7:
YY_RULE_SETUP
////#line 222 "lexer.l"
{ return POINT; }
	YY_BREAK
case 8:
YY_RULE_SETUP
////#line 224 "lexer.l"
{ return VECTOR; }
	YY_BREAK
case 9:
YY_RULE_SETUP
////#line 226 "lexer.l"
{ return LINE; }
	YY_BREAK
case 10:
YY_RULE_SETUP
////#line 228 "lexer.l"
{ return SEGMENT; }
	YY_BREAK
case 11:
YY_RULE_SETUP
////#line 230 "lexer.l"
{ return CIRCLE; }
	YY_BREAK
case 12:
YY_RULE_SETUP
////#line 232 "lexer.l"
{ return CONIC; }
	YY_BREAK
case 13:
YY_RULE_SETUP
////#line 234 "lexer.l"
{ return PARABOLA; }
	YY_BREAK
case 14:
YY_RULE_SETUP
//#line 236 "lexer.l"
{ return ELLIPSE; }
	YY_BREAK
case 15:
YY_RULE_SETUP
//#line 238 "lexer.l"
{ return HYPERBOLA; }
	YY_BREAK
case 16:
YY_RULE_SETUP
//#line 240 "lexer.l"
{ return TRANSLATION; }
	YY_BREAK
case 17:
YY_RULE_SETUP
//#line 242 "lexer.l"
{ return REFLECTION; }
	YY_BREAK
case 18:
YY_RULE_SETUP
//#line 244 "lexer.l"
{ return ROTATION; }
	YY_BREAK
case 19:
YY_RULE_SETUP
//#line 246 "lexer.l"
{ return PROJECTION; }
	YY_BREAK
case 20:
YY_RULE_SETUP
//#line 248 "lexer.l"
{ return HOMOTHECY; }
	YY_BREAK
case 21:
YY_RULE_SETUP
//#line 250 "lexer.l"
{ return INTERSECTION; }
	YY_BREAK
case 22:
YY_RULE_SETUP
//#line 252 "lexer.l"
{ return PARALLEL; }
	YY_BREAK
case 23:
YY_RULE_SETUP
//#line 254 "lexer.l"
{ return PERPENDICULAR; }
	YY_BREAK
case 24:
YY_RULE_SETUP
//#line 256 "lexer.l"
{ return MIDPOINT; }
	YY_BREAK
case 25:
YY_RULE_SETUP
//#line 258 "lexer.l"
{ return TOKBEGIN; }
	YY_BREAK
case 26:
YY_RULE_SETUP
//#line 260 "lexer.l"
{ return END; }
	YY_BREAK
case 27:
YY_RULE_SETUP
//#line 262 "lexer.l"
{ return CENTER; }
	YY_BREAK
case 28:
YY_RULE_SETUP
//#line 264 "lexer.l"
{ return VERTICES; }
	YY_BREAK
case 29:
YY_RULE_SETUP
//#line 266 "lexer.l"
{ return FOCI; }
	YY_BREAK
case 30:
YY_RULE_SETUP
//#line 268 "lexer.l"
{ return TRIANGLE; }
	YY_BREAK
case 31:
YY_RULE_SETUP
//#line 270 "lexer.l"
{ return EQUILATERAL; }
	YY_BREAK
case 32:
YY_RULE_SETUP
//#line 272 "lexer.l"
{ return ISOSCELES; }
	YY_BREAK
case 33:
YY_RULE_SETUP
//#line 274 "lexer.l"
{ return RIGHT; }
	YY_BREAK
case 34:
YY_RULE_SETUP
//#line 276 "lexer.l"
{ return BARYCENTER; }
	YY_BREAK
case 35:
YY_RULE_SETUP
//#line 278 "lexer.l"
{ return MEDIAN; }
	YY_BREAK
case 36:
YY_RULE_SETUP
//#line 280 "lexer.l"
{ return ALTITUDE; }
	YY_BREAK
case 37:
YY_RULE_SETUP
//#line 282 "lexer.l"
{ return ORTHOCENTER; }
	YY_BREAK
case 38:
YY_RULE_SETUP
//#line 284 "lexer.l"
{ return BISECTOR; }
	YY_BREAK
case 39:
YY_RULE_SETUP
//#line 286 "lexer.l"
{ return INCIRCLE; }
	YY_BREAK
case 40:
YY_RULE_SETUP
//#line 288 "lexer.l"
{ return PARALLELOGRAM; }
	YY_BREAK
case 41:
YY_RULE_SETUP
//#line 290 "lexer.l"
{ return RECTANGLE; }
	YY_BREAK
case 42:
YY_RULE_SETUP
//#line 292 "lexer.l"
{ return SQUARE; }
	YY_BREAK
case 43:
YY_RULE_SETUP
//#line 294 "lexer.l"
{ return PENTAGON; }
	YY_BREAK
case 44:
YY_RULE_SETUP
//#line 296 "lexer.l"
{ return HEXAGON; }
	YY_BREAK
case 45:
YY_RULE_SETUP
//#line 298 "lexer.l"
{ return ABSCISSA; }
	YY_BREAK
case 46:
YY_RULE_SETUP
//#line 300 "lexer.l"
{ return ORDINATE; }
	YY_BREAK
case 47:
YY_RULE_SETUP
//#line 302 "lexer.l"
{ return LENGTH; }
	YY_BREAK
case 48:
YY_RULE_SETUP
//#line 304 "lexer.l"
{ return DISTANCE; }
	YY_BREAK
case 49:
YY_RULE_SETUP
//#line 306 "lexer.l"
{ return ANGLE; }
	YY_BREAK
case 50:
YY_RULE_SETUP
//#line 308 "lexer.l"
{ return ARGUMENT; }
	YY_BREAK
case 51:
YY_RULE_SETUP
//#line 310 "lexer.l"
{ return RADIUS; }
	YY_BREAK
case 52:
YY_RULE_SETUP
//#line 312 "lexer.l"
{ return MAJOR; }
	YY_BREAK
case 53:
YY_RULE_SETUP
//#line 314 "lexer.l"
{ return MINOR; }
	YY_BREAK
case 54:
YY_RULE_SETUP
//#line 316 "lexer.l"
{ return ECCENTRICITY; }
	YY_BREAK
case 55:
YY_RULE_SETUP
//#line 318 "lexer.l"
{ return HEIGHT; }
	YY_BREAK
case 56:
YY_RULE_SETUP
//#line 320 "lexer.l"
{ return EXP; }
	YY_BREAK
case 57:
YY_RULE_SETUP
//#line 322 "lexer.l"
{ return LN; }
	YY_BREAK
case 58:
YY_RULE_SETUP
//#line 324 "lexer.l"
{ return TOKPI; }
	YY_BREAK
case 59:
YY_RULE_SETUP
//#line 326 "lexer.l"
{ return SIN; }
	YY_BREAK
case 60:
YY_RULE_SETUP
//#line 328 "lexer.l"
{ return COS; }
	YY_BREAK
case 61:
YY_RULE_SETUP
//#line 330 "lexer.l"
{ return TAN; }
	YY_BREAK
case 62:
YY_RULE_SETUP
//#line 332 "lexer.l"
{ return ASIN; }
	YY_BREAK
case 63:
YY_RULE_SETUP
//#line 334 "lexer.l"
{ return ACOS; }
	YY_BREAK
case 64:
YY_RULE_SETUP
//#line 336 "lexer.l"
{ return ATAN; }
	YY_BREAK
case 65:
YY_RULE_SETUP
//#line 338 "lexer.l"
{ return TOKDEG; }
	YY_BREAK
case 66:
YY_RULE_SETUP
//#line 340 "lexer.l"
{ return TOKRAD; }
	YY_BREAK
case 67:
YY_RULE_SETUP
//#line 342 "lexer.l"
{ return SQRT; }
	YY_BREAK
case 68:
YY_RULE_SETUP
//#line 344 "lexer.l"
{ return TOKABS; }
	YY_BREAK
case 69:
YY_RULE_SETUP
//#line 346 "lexer.l"
{ return SIGN; }
	YY_BREAK
case 70:
YY_RULE_SETUP
//#line 348 "lexer.l"
{ return CEIL; }
	YY_BREAK
case 71:
YY_RULE_SETUP
//#line 350 "lexer.l"
{ return FLOOR; }
	YY_BREAK
case 72:
YY_RULE_SETUP
//#line 352 "lexer.l"
{ return ROUND; }
	YY_BREAK
case 73:
YY_RULE_SETUP
//#line 354 "lexer.l"
{ return TOKMIN; }
	YY_BREAK
case 74:
YY_RULE_SETUP
//#line 356 "lexer.l"
{ return TOKMAX; }
	YY_BREAK
case 75:
YY_RULE_SETUP
//#line 358 "lexer.l"
{ return TOKCLAMP; }
	YY_BREAK
case 76:
YY_RULE_SETUP
//#line 360 "lexer.l"
{ return EQ; }
	YY_BREAK
case 77:
YY_RULE_SETUP
//#line 362 "lexer.l"
{ return NEQ; }
	YY_BREAK
case 78:
YY_RULE_SETUP
//#line 364 "lexer.l"
{ return LEQ; }
	YY_BREAK
case 79:
YY_RULE_SETUP
//#line 366 "lexer.l"
{ return GEQ; }
	YY_BREAK
case 80:
YY_RULE_SETUP
//#line 368 "lexer.l"
{ return AND; }
	YY_BREAK
case 81:
YY_RULE_SETUP
//#line 370 "lexer.l"
{ return OR; }
	YY_BREAK
case 82:
YY_RULE_SETUP
//#line 372 "lexer.l"
{ return NOT; }
	YY_BREAK
case 83:
YY_RULE_SETUP
//#line 374 "lexer.l"
{ return FRAME; }
	YY_BREAK
case 84:
YY_RULE_SETUP
//#line 376 "lexer.l"
{ return COLOR; }
	YY_BREAK
case 85:
YY_RULE_SETUP
//#line 378 "lexer.l"
{ return BLACK; }
	YY_BREAK
case 86:
YY_RULE_SETUP
//#line 380 "lexer.l"
{ return DARKGRAY; }
	YY_BREAK
case 87:
YY_RULE_SETUP
//#line 382 "lexer.l"
{ return GRAY; }
	YY_BREAK
case 88:
YY_RULE_SETUP
//#line 384 "lexer.l"
{ return LIGHTGRAY; }
	YY_BREAK
case 89:
YY_RULE_SETUP
//#line 386 "lexer.l"
{ return WHITE; }
	YY_BREAK
case 90:
YY_RULE_SETUP
//#line 388 "lexer.l"
{ return RED; }
	YY_BREAK
case 91:
YY_RULE_SETUP
//#line 390 "lexer.l"
{ return GREEN; }
	YY_BREAK
case 92:
YY_RULE_SETUP
//#line 392 "lexer.l"
{ return BLUE; }
	YY_BREAK
case 93:
YY_RULE_SETUP
//#line 394 "lexer.l"
{ return CYAN; }
	YY_BREAK
case 94:
YY_RULE_SETUP
//#line 396 "lexer.l"
{ return MAGENTA; }
	YY_BREAK
case 95:
YY_RULE_SETUP
//#line 398 "lexer.l"
{ return YELLOW; }
	YY_BREAK
case 96:
YY_RULE_SETUP
//#line 400 "lexer.l"
{ return THICKNESS; }
	YY_BREAK
case 97:
YY_RULE_SETUP
//#line 402 "lexer.l"
{ return FONT; }
	YY_BREAK
case 98:
YY_RULE_SETUP
//#line 404 "lexer.l"
{ return TRICKS; }
	YY_BREAK
case 99:
YY_RULE_SETUP
//#line 406 "lexer.l"
{ return EXPORT; }
	YY_BREAK
case 100:
YY_RULE_SETUP
//#line 408 "lexer.l"
{ return DRAW; }
	YY_BREAK
case 101:
YY_RULE_SETUP
//#line 410 "lexer.l"
{ return LABEL; }
	YY_BREAK
case 102:
YY_RULE_SETUP
//#line 412 "lexer.l"
{ return MARK; }
	YY_BREAK
case 103:
YY_RULE_SETUP
//#line 414 "lexer.l"
{ return DOT; }
	YY_BREAK
case 104:
YY_RULE_SETUP
//#line 416 "lexer.l"
{ return DISC; }
	YY_BREAK
case 105:
YY_RULE_SETUP
//#line 418 "lexer.l"
{ return BOX; }
	YY_BREAK
case 106:
YY_RULE_SETUP
//#line 420 "lexer.l"
{ return CROSS; }
	YY_BREAK
case 107:
YY_RULE_SETUP
//#line 422 "lexer.l"
{ return PLUS; }
	YY_BREAK
case 108:
YY_RULE_SETUP
//#line 424 "lexer.l"
{ return NOARROW; }
	YY_BREAK
case 109:
YY_RULE_SETUP
//#line 426 "lexer.l"
{ return ARROW; }
	YY_BREAK
case 110:
YY_RULE_SETUP
//#line 428 "lexer.l"
{ return BACKARROW; }
	YY_BREAK
case 111:
YY_RULE_SETUP
//#line 430 "lexer.l"
{ return DOUBLEARROW; }
	YY_BREAK
case 112:
YY_RULE_SETUP
//#line 432 "lexer.l"
{ return ENTIRE;}
	YY_BREAK
case 113:
YY_RULE_SETUP
//#line 434 "lexer.l"
{ return HALFLINE; }
	YY_BREAK
case 114:
YY_RULE_SETUP
//#line 436 "lexer.l"
{ return BACKHALFLINE; }
	YY_BREAK
case 115:
YY_RULE_SETUP
//#line 438 "lexer.l"
{ return STYLE; }
	YY_BREAK
case 116:
YY_RULE_SETUP
//#line 440 "lexer.l"
{ return FULL; }
	YY_BREAK
case 117:
YY_RULE_SETUP
//#line 442 "lexer.l"
{ return DOTTED; }
	YY_BREAK
case 118:
YY_RULE_SETUP
//#line 444 "lexer.l"
{ return DASHED; }
	YY_BREAK
case 119:
YY_RULE_SETUP
//#line 446 "lexer.l"
{ return SIMPLE; }
	YY_BREAK
case 120:
YY_RULE_SETUP
//#line 448 "lexer.l"
{ return DOUBLE; }
	YY_BREAK
case 121:
YY_RULE_SETUP
//#line 450 "lexer.l"
{ return TRIPLE; }
	YY_BREAK
case 122:
YY_RULE_SETUP
//#line 452 "lexer.l"
{ return INTERACTIVE; }
	YY_BREAK
case 123:
YY_RULE_SETUP
//#line 454 "lexer.l"
{ return UP; }
	YY_BREAK
case 124:
YY_RULE_SETUP
//#line 456 "lexer.l"
{ return STROKES; }
	YY_BREAK
case 125:
YY_RULE_SETUP
//#line 458 "lexer.l"
{ return TRACE; }
	YY_BREAK
/* Variables */
case 126:
YY_RULE_SETUP
//#line 462 "lexer.l"
{
    symrec *s;
    s = getsym (yytext);
    if (s == NULL) 
	s = putsym (yytext); 
    yylval.ptr = s;
    switch (s->type)
    {
	case NUMBER	: return NUMBER_VARIABLE;
	case POINT	: return POINT_VARIABLE;
	case VECTOR	: return VECTOR_VARIABLE;
	case LINE	: return LINE_VARIABLE;
	case SEGMENT	: return SEGMENT_VARIABLE;
	case CIRCLE	: return CIRCLE_VARIABLE;
	case CONIC	: return CONIC_VARIABLE;
	case VARIABLE	: return VARIABLE;
    }
}
	YY_BREAK
/* Semi-colons and \r are handled as \n */
case 127:
YY_RULE_SETUP
//#line 483 "lexer.l"
{ return '\n'; }
	YY_BREAK
/* New line */
case 128:
/* rule 128 can match eol */
YY_RULE_SETUP
//#line 487 "lexer.l"
{ lineno++; return '\n'; }
	YY_BREAK
/* Trace command block */
case 129:
YY_RULE_SETUP
//#line 491 "lexer.l"
{

    if (first) {
	count = 300;
	pos = lineno;
	first = 0;
	return '\n';
    } else return '{';
}
	YY_BREAK
case 130:
YY_RULE_SETUP
//#line 501 "lexer.l"
{

    if (count == 300)
	lineno -= 299*(lineno-pos);
    if (--count == 0)
	first = 1;
    return '}';
}
	YY_BREAK
/* Anything else */
case 131:
YY_RULE_SETUP
//#line 512 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
/* Start compiling */
case 132:
YY_RULE_SETUP
//#line 516 "lexer.l"
ECHO;
	YY_BREAK
//#line 1907 "lexer.cpp"
case YY_STATE_EOF(INITIAL):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			size_t num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 568 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 568 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 567);

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp )
{
	register char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up yytext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (yy_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param str a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * str )
{
    
	return yy_scan_bytes(str,strlen(str) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * bytes, int  len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
    	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
    	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

//#line 516 "lexer.l"



QString EukParser::parseEukText()
{
if (this->nomfichier=="erreur") return QString("Erreur");
result.clear();
filter = 0;
lineno = 1;
first = 1;
inputmode = 1;
strokes = 151;
undefined = 1;
drawing_style = FULL;
clearsym();
clearsave();
FILE *file;
int size, number, file_length;
file = fopen (this->nomfichier.toLatin1().data(), "r");
file_length = 0;
size = 1024;
number = 1024;
buffer = (char *) malloc (size+1);
while (number == 1024) 
	{
	number = fread (buffer + file_length, 1, 1024, file);
	file_length += number;
	if (size == file_length) 
		{
		size *= 2;
		buffer = (char *) realloc (buffer, size+1);
		}
	}
fclose (file);
buffer[file_length] = '\0';
YY_BUFFER_STATE buff = yy_scan_string(buffer);
yyparse ();
yy_delete_buffer(buff);
return result;
}

