Name: pdfadd
Summary: Création de graphiques pour pdflatex/asymptote
Version: 2.0.1
Release: xm1
License: GPLv2+
Group: Applications/Publishing
#Group: Publishing
Source: pdfadd-%{version}.tar.bz2
Packager: Pascal Brachet
Url: https://www.xm1math.net/pdfadd/

%if 0%{?fedora}
BuildRequires: gcc-c++
BuildRequires: qt5-qtbase-devel
BuildRequires: qt5-qttools-devel
%endif

%if 0%{?suse_version}
%if 0%{?suse_version}>1310
BuildRequires: libQt5Core-devel
BuildRequires: libQt5Gui-devel
BuildRequires: libQt5Concurrent-devel
BuildRequires: libQt5Network-devel
BuildRequires: libQt5PrintSupport-devel
BuildRequires: libQt5Widgets-devel
BuildRequires: libqt5-qtbase-devel
BuildRequires: libqt5-qtbase-common-devel
BuildRequires: libqt5-qttools-devel
%endif
%endif

%description
Assistants de création de graphiques pour pdflatex/asymptote

%global debug_package %{nil}

%prep
%setup -q

%build
PREFIX=%{buildroot}%{_prefix}
%if 0%{?suse_version}
%if 0%{?suse_version}>1310
qmake-qt5 CONFIG-=debug NO_APPDATA=1 pdfadd.pro
%else
qmake CONFIG-=debug NO_APPDATA=1 pdfadd.pro
%endif
%endif
%if 0%{?fedora}
qmake-qt5 CONFIG-=debug pdfadd.pro
%endif

make %{?_smp_mflags}

%install
make INSTALL_ROOT=%{buildroot} install

%files
%defattr(-,root,root,-)
%{_bindir}/pdfadd
%{_datadir}/applications/pdfadd.desktop
%{_datadir}/mime/packages/x-pdfadd.xml
%if 0%{?suse_version}
%else
%{_datadir}/metainfo/pdfadd.appdata.xml
%endif
%{_datadir}/pixmaps/pdfadd.png
%{_datadir}/pdfadd/AUTHORS
%{_datadir}/pdfadd/COPYING
%{_datadir}/pdfadd/pdfadd.svg
%{_datadir}/pdfadd/pdfadd128x128.png
%{_datadir}/pdfadd/pdfadd16x16.png
%{_datadir}/pdfadd/pdfadd22x22.png
%{_datadir}/pdfadd/pdfadd32x32.png
%{_datadir}/pdfadd/pdfadd48x48.png
%{_datadir}/pdfadd/pdfadd64x64.png
%{_datadir}/pdfadd/exemple_arbre1.pag
%{_datadir}/pdfadd/exemple_arbre2.pag
%{_datadir}/pdfadd/exemple_binomiale1.pag
%{_datadir}/pdfadd/exemple_boites1.pag
%{_datadir}/pdfadd/exemple_boites2.pag
%{_datadir}/pdfadd/exemple_cercletrigo1.pag
%{_datadir}/pdfadd/exemple_courbes1.pag
%{_datadir}/pdfadd/exemple_espace1.pag
%{_datadir}/pdfadd/exemple_espace2.pag
%{_datadir}/pdfadd/exemple_geometrie1.pag
%{_datadir}/pdfadd/exemple_geometrie2.pag
%{_datadir}/pdfadd/exemple_graphe1.pag
%{_datadir}/pdfadd/exemple_graphe2.pag
%{_datadir}/pdfadd/exemple_graphe3.pag
%{_datadir}/pdfadd/exemple_graphe4.pag
%{_datadir}/pdfadd/exemple_histo1.pag
%{_datadir}/pdfadd/exemple_suite1.pag
%{_datadir}/pdfadd/exemple_suite2.pag
%{_datadir}/pdfadd/exemple_tabvar1.pag
%{_datadir}/pdfadd/qt_fr.qm
%{_datadir}/pdfadd/pdftabvar.tex
